<!DOCTYPE html>
<html class="writer-html5" lang="en" >
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>scripts.multiple_candidates.mulcan.strategy &mdash; RDstar_light  documentation</title>
      <link rel="stylesheet" href="../../../../_static/pygments.css" type="text/css" />
      <link rel="stylesheet" href="../../../../_static/css/theme.css" type="text/css" />
  <!--[if lt IE 9]>
    <script src="../../../../_static/js/html5shiv.min.js"></script>
  <![endif]-->
  
        <script data-url_root="../../../../" id="documentation_options" src="../../../../_static/documentation_options.js"></script>
        <script src="../../../../_static/jquery.js"></script>
        <script src="../../../../_static/underscore.js"></script>
        <script src="../../../../_static/_sphinx_javascript_frameworks_compat.js"></script>
        <script src="../../../../_static/doctools.js"></script>
    <script src="../../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../../genindex.html" />
    <link rel="search" title="Search" href="../../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >
            <a href="../../../../index.html" class="icon icon-home"> RDstar_light
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../../lib.html">lib package</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../../../scripts.html">scripts.multiple_candidates package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../../index.html">RDstar_light</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../../index.html" class="icon icon-home"></a> &raquo;</li>
          <li><a href="../../../index.html">Module code</a> &raquo;</li>
      <li>scripts.multiple_candidates.mulcan.strategy</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for scripts.multiple_candidates.mulcan.strategy</h1><div class="highlight"><pre>
<span></span>
<span class="sd">&quot;&quot;&quot; Module that defines the class ``MucStrat`` that allows to cook up</span>
<span class="sd">the name of the output subfolder according to</span>
<span class="sd">&quot;&quot;&quot;</span>


<span class="kn">from</span> <span class="nn">typing</span> <span class="kn">import</span> <span class="n">Optional</span>
<span class="kn">from</span> <span class="nn">lib</span> <span class="kn">import</span> <span class="n">assertion</span>
<span class="kn">from</span> <span class="nn">multiple_candidates.definition</span> <span class="kn">import</span> <span class="n">strategy</span>

<span class="c1">#: Associates a ``muc_strat`` with a ``full muc_strategy`` with wildcards</span>
<span class="n">dict_muc_strat_to_full_muc_strat_wildcards</span> <span class="o">=</span> <span class="p">{</span>
    <span class="n">muc_strat</span><span class="p">:</span> <span class="s2">&quot;-&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span>
        <span class="p">[</span><span class="n">muc_strat</span><span class="p">]</span> <span class="o">+</span> <span class="p">[</span><span class="sa">f</span><span class="s2">&quot;{{</span><span class="si">{param_name}</span><span class="s2">}}&quot;</span> <span class="k">for</span> <span class="n">param_name</span> <span class="ow">in</span> <span class="n">list_param_names</span><span class="p">]</span>
    <span class="p">)</span>
    <span class="k">for</span> <span class="n">muc_strat</span><span class="p">,</span> <span class="n">list_param_names</span> <span class="ow">in</span> <span class="n">strategy</span><span class="o">.</span><span class="n">dict_muc_strat_params</span><span class="o">.</span><span class="n">items</span><span class="p">()</span>
<span class="p">}</span>


<div class="viewcode-block" id="MucStrat"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.strategy.MucStrat">[docs]</a><span class="k">class</span> <span class="nc">MucStrat</span><span class="p">():</span>
    <span class="sd">&quot;&quot;&quot; Class to deal with strategies and their subfolders and names.</span>

<span class="sd">    Attributes:</span>
<span class="sd">        muc_strat: strategy (``sc``, ``random`` or ``opt``)</span>
<span class="sd">        params: parameters of the strategy (e.g., ``seed`` for ``random``)</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="c1"># CONSTRUCTORS ========================================================</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span>
        <span class="bp">self</span><span class="p">,</span> <span class="n">muc_strat</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span>
        <span class="o">**</span><span class="n">params</span>
    <span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">params</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">if</span> <span class="n">muc_strat</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">muc_strat</span> <span class="o">=</span> <span class="n">muc_strat</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">assertion</span><span class="o">.</span><span class="n">assert_var_in_list</span><span class="p">(</span><span class="n">muc_strat</span><span class="p">,</span> <span class="n">strategy</span><span class="o">.</span><span class="n">list_muc_strats</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">muc_strat</span> <span class="o">=</span> <span class="n">muc_strat</span>
            <span class="k">for</span> <span class="n">param_name</span> <span class="ow">in</span> <span class="n">strategy</span><span class="o">.</span><span class="n">dict_muc_strat_params</span><span class="p">[</span><span class="n">muc_strat</span><span class="p">]:</span>
                <span class="n">param</span> <span class="o">=</span> <span class="n">params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">param_name</span><span class="p">,</span>
                                   <span class="n">strategy</span><span class="o">.</span><span class="n">default_params</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">param_name</span><span class="p">))</span>
                <span class="n">assertion</span><span class="o">.</span><span class="n">gen_assert</span><span class="p">(</span><span class="n">param</span><span class="p">,</span>
                                     <span class="n">strategy</span><span class="o">.</span><span class="n">dict_format_params</span><span class="p">[</span><span class="n">param_name</span><span class="p">])</span>
                <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="p">[</span><span class="n">param_name</span><span class="p">]</span> <span class="o">=</span> <span class="n">param</span>

<div class="viewcode-block" id="MucStrat.from_full_muc_strat"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.strategy.MucStrat.from_full_muc_strat">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">from_full_muc_strat</span><span class="p">(</span><span class="n">full_muc_strat</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]):</span>
        <span class="sd">&quot;&quot;&quot; Define ``MucStrat`` from the full strategy ``full_muc_strat``.</span>

<span class="sd">        Args:</span>
<span class="sd">            full_muc_strat: a string that indicates the strategy of</span>
<span class="sd">                selection of multiple candidates.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">full_muc_strat</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">muc_strat</span> <span class="o">=</span> <span class="kc">None</span>
            <span class="n">params</span> <span class="o">=</span> <span class="p">{}</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">assertion</span><span class="o">.</span><span class="n">assert_type</span><span class="p">(</span><span class="n">full_muc_strat</span><span class="p">,</span> <span class="nb">str</span><span class="p">)</span>
            <span class="n">list_wildcard_values</span> <span class="o">=</span> <span class="n">full_muc_strat</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s1">&#39;-&#39;</span><span class="p">)</span>

            <span class="n">muc_strat</span> <span class="o">=</span> <span class="n">list_wildcard_values</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
            <span class="n">assertion</span><span class="o">.</span><span class="n">assert_var_in_list</span><span class="p">(</span><span class="n">muc_strat</span><span class="p">,</span>
                                         <span class="n">strategy</span><span class="o">.</span><span class="n">list_muc_strats</span><span class="p">)</span>
            <span class="n">list_param_values</span> <span class="o">=</span> <span class="n">list_wildcard_values</span><span class="p">[</span><span class="mi">1</span><span class="p">:]</span>

            <span class="n">list_param_names</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">dict_muc_strat_params</span><span class="p">[</span><span class="n">muc_strat</span><span class="p">]</span>

            <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_param_names</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">list_param_values</span><span class="p">),</span> \
                <span class="sa">f</span><span class="s2">&quot;The list of parameters values </span><span class="si">{list_param_values}</span><span class="s2"> given &quot;</span>\
                <span class="sa">f</span><span class="s2">&quot;by ``full_muc_strat`` </span><span class="si">{full_muc_strat}</span><span class="s2"> and the list of &quot;</span> \
                <span class="sa">f</span><span class="s2">&quot;parameter names </span><span class="si">{list_param_names}</span><span class="s2"> should be same-sized.&quot;</span>

            <span class="n">params</span> <span class="o">=</span> <span class="p">{</span>
                <span class="n">param_name</span><span class="p">:</span> <span class="n">param_value</span>
                <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param_value</span> <span class="ow">in</span> <span class="nb">zip</span><span class="p">(</span>
                    <span class="n">list_param_names</span><span class="p">,</span> <span class="n">list_param_values</span>
                <span class="p">)</span>
            <span class="p">}</span>
            <span class="k">return</span> <span class="n">MucStrat</span><span class="p">(</span><span class="n">muc_strat</span><span class="p">,</span> <span class="o">**</span><span class="n">params</span><span class="p">)</span></div>

<div class="viewcode-block" id="MucStrat.from_subfolder"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.strategy.MucStrat.from_subfolder">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">from_subfolder</span><span class="p">(</span><span class="n">subfolder</span><span class="p">:</span> <span class="n">Optional</span><span class="p">[</span><span class="nb">str</span><span class="p">]):</span>
        <span class="sd">&quot;&quot;&quot; Define ``MucStrat`` from the subfolder.</span>

<span class="sd">        subfolder: Subfolder for a given multiple candidate</span>
<span class="sd">                selection strategy. It must be a value of the dictionnary</span>
<span class="sd">                ``dict_muc_strat_to_subfolder``.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="n">full_muc_strat</span> <span class="o">=</span> <span class="n">MucStrat</span><span class="o">.</span><span class="n">_get_full_muc_strat_from_subfolder</span><span class="p">(</span><span class="n">subfolder</span><span class="p">)</span>
        <span class="k">return</span> <span class="n">MucStrat</span><span class="o">.</span><span class="n">from_full_muc_strat</span><span class="p">(</span><span class="n">full_muc_strat</span><span class="p">)</span></div>

    <span class="c1"># PROPERTIES ==========================================================</span>
    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">subfolder_wildcards</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Subfolder with parameters as wildcards</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">muc_strat</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="s2">&quot;&quot;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">strategy</span><span class="o">.</span><span class="n">subfolder_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                <span class="n">full_muc_strat</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">full_muc_strat_wildcards</span><span class="p">)</span>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">full_muc_strat_wildcards</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; A string that indicates the strategy of selection of</span>
<span class="sd">        multiple candidates.</span>

<span class="sd">        * ``sc``: all the multiple candidates are removed</span>
<span class="sd">        * ``random_{seed}``: one single candidate is selected for every \</span>
<span class="sd">        multiple events, with random seed `{seed}`</span>
<span class="sd">        * ``opt_{opt_best}_{opt_column}``: one single candidate is \</span>
<span class="sd">        selected, that is, the one that minimises \</span>
<span class="sd">        (``opt_best == &quot;min&quot;``) or maximises (``opt_best == &quot;max&quot;``) \</span>
<span class="sd">         the column ``opt_column``</span>
<span class="sd">        * ``None``: all the multiple candidates are kept</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">muc_strat</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">dict_muc_strat_to_full_muc_strat_wildcards</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">muc_strat</span><span class="p">]</span>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">subfolder</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Subfolder for the given multiple candidate strategy.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">muc_strat</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">return</span> <span class="s2">&quot;&quot;</span>

        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">strategy</span><span class="o">.</span><span class="n">subfolder_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                <span class="n">full_muc_strat</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">full_muc_strat</span><span class="p">)</span>

    <span class="nd">@property</span>
    <span class="k">def</span> <span class="nf">full_muc_strat</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; ``full_muc_strat_wildcards`` where the parameter names are</span>
<span class="sd">        replaced by their values.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">muc_strat</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">full_muc_strat_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="o">**</span><span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="p">)</span>

<div class="viewcode-block" id="MucStrat.get_param"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.strategy.MucStrat.get_param">[docs]</a>    <span class="k">def</span> <span class="nf">get_param</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">name</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">params</span><span class="p">[</span><span class="n">name</span><span class="p">]</span></div>

    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">_get_full_muc_strat_from_subfolder</span><span class="p">(</span><span class="n">subfolder</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Get the full strategy from the ``mulcan`` subfolder.</span>

<span class="sd">        Args:</span>
<span class="sd">            subfolder: Subfolder for a given multiple candidate</span>
<span class="sd">                selection strategy. It must be a value of the dictionnary</span>
<span class="sd">                ``dict_muc_strat_to_subfolder``.</span>

<span class="sd">        Returns:</span>
<span class="sd">            full_muc_strat: a string that indicates the strategy of</span>
<span class="sd">                selection of multiple candidates.</span>

<span class="sd">                * ``sc``: all the multiple candidates are removed</span>
<span class="sd">                * ``random_{seed}``: one single candidate is selected for \</span>
<span class="sd">                every multiple events, with random seed ``{seed}``</span>
<span class="sd">                * ``opt_{opt_best}_{opt_column}`: one single candidate is \</span>
<span class="sd">                selected, that is, the one that minimises \</span>
<span class="sd">                (``opt_best == &quot;min&quot;``) \</span>
<span class="sd">                or maximises (``opt_best == &quot;max&quot;``) \</span>
<span class="sd">                the column ``opt_column``</span>
<span class="sd">                * ``None``: all the multiple candidates are kept</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">subfolder</span><span class="o">.</span><span class="n">startswith</span><span class="p">(</span><span class="s2">&quot;mulcan/&quot;</span><span class="p">):</span>
            <span class="k">return</span> <span class="n">subfolder</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s2">&quot;mulcan/&quot;</span><span class="p">,</span> <span class="s2">&quot;&quot;</span><span class="p">)</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;/&#39;</span><span class="p">,</span> <span class="s1">&#39;&#39;</span><span class="p">)</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">assert</span> <span class="n">subfolder</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span>
            <span class="k">return</span>

<div class="viewcode-block" id="MucStrat.get_shell_arguments"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.strategy.MucStrat.get_shell_arguments">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_shell_arguments</span><span class="p">(</span><span class="n">subfolder</span><span class="p">:</span> <span class="nb">str</span><span class="p">)</span> <span class="o">-&gt;</span> <span class="nb">str</span><span class="p">:</span>
        <span class="sd">&quot;&quot;&quot; Get the shell arguments to pass to the script</span>
<span class="sd">        ``a_select_multiple_candidates/run.py`` that corresponds to the</span>
<span class="sd">        subfolder ``subfolder``.</span>

<span class="sd">        Args:</span>
<span class="sd">            subfolder: Subfolder for a given multiple candidate</span>
<span class="sd">                selection strategy. It must be a value of the dictionnary</span>
<span class="sd">                ``dict_muc_strat_to_subfolder``.</span>

<span class="sd">        Returns:</span>
<span class="sd">            string correspond to the passed shell arguments</span>

<span class="sd">        Examples:</span>
<span class="sd">            &gt;&gt;&gt; MucStrat.get_shell_arguments(&quot;mulcan/random-20/&quot;)</span>
<span class="sd">            &quot;-strat random -s 20&quot;</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">subfolder</span> <span class="o">==</span> <span class="s2">&quot;&quot;</span><span class="p">:</span>
            <span class="k">return</span> <span class="s2">&quot;&quot;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">mucStrat</span> <span class="o">=</span> <span class="n">MucStrat</span><span class="o">.</span><span class="n">from_subfolder</span><span class="p">(</span><span class="n">subfolder</span><span class="p">)</span>
            <span class="n">dict_shell_args</span> <span class="o">=</span> <span class="p">{</span>
                <span class="s2">&quot;muc_strat&quot;</span><span class="p">:</span> <span class="n">mucStrat</span><span class="o">.</span><span class="n">muc_strat</span><span class="p">,</span>
                <span class="o">**</span><span class="n">mucStrat</span><span class="o">.</span><span class="n">params</span>
            <span class="p">}</span>
            <span class="n">list_shell_args</span> <span class="o">=</span> <span class="p">[]</span>
            <span class="k">for</span> <span class="n">param_name</span><span class="p">,</span> <span class="n">param_value</span> <span class="ow">in</span> <span class="n">dict_shell_args</span><span class="o">.</span><span class="n">items</span><span class="p">():</span>
                <span class="n">shell_arg</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">dict_parser_arguments</span><span class="p">[</span><span class="n">param_name</span><span class="p">][</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
                <span class="n">list_shell_args</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;-</span><span class="si">{shell_arg}</span><span class="s2"> </span><span class="si">{param_value}</span><span class="s2">&quot;</span><span class="p">)</span>

            <span class="k">return</span> <span class="s2">&quot; &quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">list_shell_args</span><span class="p">)</span></div>

<div class="viewcode-block" id="MucStrat.get_subfolder_from_full_muc_strat"><a class="viewcode-back" href="../../../../scripts.multiple_candidates.mulcan.html#scripts.multiple_candidates.mulcan.strategy.MucStrat.get_subfolder_from_full_muc_strat">[docs]</a>    <span class="nd">@staticmethod</span>
    <span class="k">def</span> <span class="nf">get_subfolder_from_full_muc_strat</span><span class="p">(</span><span class="n">full_muc_strat</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
        <span class="sd">&quot;&quot;&quot; Get the subfolder name from ``full_muc_strat``.</span>

<span class="sd">        Args:</span>
<span class="sd">            full_muc_strat: a string that indicates the strategy of</span>
<span class="sd">                selection of multiple candidates.</span>

<span class="sd">                * ``sc``: all the multiple candidates are removed</span>
<span class="sd">                * ``random_{seed}``: one single candidate is selected for \</span>
<span class="sd">                every multiple events, with random seed ``{seed}``</span>
<span class="sd">                * ``opt_{opt_best}_{opt_column}``: one single candidate is \</span>
<span class="sd">                selected, that is, the one that minimises \</span>
<span class="sd">                (``opt_best == &quot;min&quot;``) \</span>
<span class="sd">                or maximises (``opt_best == &quot;max&quot;``) \</span>
<span class="sd">                the column ``opt_column``</span>
<span class="sd">                * ``None``: all the multiple candidates are kept</span>

<span class="sd">        Returns:</span>
<span class="sd">            Subfolder for a given multiple candidate</span>
<span class="sd">            selection strategy. It must be a value of the dictionnary</span>
<span class="sd">            ``dict_muc_strat_to_subfolder``.</span>
<span class="sd">        &quot;&quot;&quot;</span>
        <span class="k">if</span> <span class="n">full_muc_strat</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">or</span> <span class="n">full_muc_strat</span> <span class="ow">in</span> <span class="p">[</span><span class="s2">&quot;&quot;</span><span class="p">,</span> <span class="s2">&quot;all&quot;</span><span class="p">]:</span>
            <span class="k">return</span> <span class="s2">&quot;&quot;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="n">strategy</span><span class="o">.</span><span class="n">subfolder_wildcards</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
                <span class="n">full_muc_strat</span><span class="o">=</span><span class="n">full_muc_strat</span><span class="p">)</span></div></div>
</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright .</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>